#pragma once

#include "angles/angles.h"
#include "behaviortree_ros2/bt_action_node.hpp"
#include "tf2/utils.hpp"
#include "tf2_geometry_msgs/tf2_geometry_msgs.hpp"
#include "toid_bt/plugin.hpp"
#include "toid_msgs/action/simple_translate_x.hpp"

namespace toid
{

class TranslateXNode : public BT::RosActionNode<toid_msgs::action::SimpleTranslateX>
{
public:
  TranslateXNode(
    const std::string & name, const BT::NodeConfig & conf, const BT::RosNodeParams & params,
    PoseFunc pose)
  : BT::RosActionNode<toid_msgs::action::SimpleTranslateX>(name, conf, params), get_pose(pose)
  {
  }

  static BT::PortsList providedPorts()
  {
    return providedBasicPorts({
      BT::InputPort<double>("x"),
      BT::InputPort<double>("max_speed", 0, {}),
      //BT::InputPort<double>("options"),
    });
  }

  bool setGoal(Goal & goal) override
  {
    auto x_goal = getInput<double>("x").value();
    auto max_speed = getInput<double>("max_speed").value();

    goal.distance = x_goal;
    goal.max_speed = max_speed;

    return true;
  }

  void onHalt() override { RCLCPP_INFO(logger(), "%s: onHalt", name().c_str()); }

  BT::NodeStatus onResultReceived(const WrappedResult & wr) override
  {
    return (wr.result->error_code == 0) ? BT::NodeStatus::SUCCESS : BT::NodeStatus::FAILURE;
  }

  BT::NodeStatus onFailure(BT::ActionNodeErrorCode error) override
  {
    RCLCPP_ERROR(logger(), "%s: onFailure with error: %s", name().c_str(), toStr(error));
    return BT::NodeStatus::FAILURE;
  }

  PoseFunc get_pose;
};

}  // namespace toid